# Fairgate Standard API - FSA
## SDK for the FSA
This is the SDK for the FSA that aims to help you get started quickly with
usable example code to show you how to use the FSA communication and keys
correctly. We also included a .http-request file you can use with your IDE
to quickly test your code with the API during development. We also included
config files for the use in Postman if you prefer that.

## Examples
### HTTP Requests
This is where the .http-request files are located. You can use those to start
toying around with the FSA before you start or during your development. 
* FSA-generated-requests.http (contains the requests)
* http-client.env.json (contains the environment variables for the requests)

#### Postman
Here are the 2 Postman config files that you can import in Postman and use
right away. They may not always be up to date, so you may want to check the
official FSA documentation for the latest information.
* Fairgate Standard API.postman_collection.json
* FG FSA API_PROD.postman_environment.json

### PHP Examples
You find some PHP files showing you several examples in stages of how to use
the FSA. You can use those to get started quickly with your own code. It also
contains the composer.json that shows you the dependencies you need to use the
examples. We assume the use of PHP 8.2 or higher in the examples.

You're not obliged to use the exact same libraries as in the examples, you are
free to use whatever suits you best. We're using standard protocols and formats
so that you will find numerous other options online. The examples still can be
useful even if you use another programming language than PHP to understand the
basic usage of the FSA.

#### REST-API
The API is accessed via REST. You can use the HTTP requests directly or use
a library that helps you with the communication.

#### JWT - JSON Web Tokens
We use the JWT standard for authentication. The example shows how to check the
JWT's content and also verify it's signature for security reasons. You can use
the JWT library of your choice to do that.

Use the online JWT debugger to check the content of your JWT: https://jwt.io/

## OpenAPI
Here you find the openapi file we use in FSA and we also embedded with the
documentation on the FSA  server. You fine here the API calls, the
datafields for input and output and results and their specifics. You find
possible success and error codes.

You can also use the openapi viewer of your IDE like in JetBrains:
* https://plugins.jetbrains.com/plugin/14837-openapi-swagger-editor

Or the Swagger Editors online:
* https://editor-next.swagger.io/ (new version)
* https://editor.swagger.io/ (old version)

## Disclaimer & Legal Terms
The FSA (Fairgate Standard API) is a product of Fairgate AG, Switzerland.
The FSA is a product that is constantly in development. The FSA is provided as
is and without any warranty. Fairgate AG is not liable for any damages caused
by the use of the FSA. The code examples and files provided here are for
educational purposes only and are not intended to be used in production
environments. Fairgate is not responsible for how the FSA API is used and by
whom, nor for the external applications that use it, also not for any
malfunctions, security risks or failures or other any kind of misuse outside
of the Fairgate solution. Fairgate AG is not liable for any damages caused by
the use of the code examples and files provided here. The persons with access
to a Fairgate client are responsible to manage who gets access to their
organisation’s data and which data is used for what purposes. The users of the
FSA API, both the developers and the operators of external applications and web
services have the responsibility to use the FSA in a correct and legal way. The
use of the FSA is subject to the legal terms of Fairgate AG. The SDK and all
it's content can't be distributed without the written consent of Fairgate AG.
It can only be used by Fairgate customer that booked the FSA-Service and only
during that time of the booking. The SDK and all it's content is the
intellectual property of Fairgate AG, except with the 3rd party code and
libraries used within. This is in addition to the legal terms of Fairgate AG.
All rights reserved.

Copyright by Fairgate AG Switzerland, 2024